** -----------------
** Master do-file 
** -----------------
** Design of Partial Population Experiments with an Application to Spillovers in Tax Compliance
*Date of intervention: September 28th - October 7th, 2020
*For payments due in the October billing period of 2020 (month 10) as well as past due debt (if any)

version 17
set more off

set varabbrev on


*** Set working path

cd "CHANGE_PATH_HERE"
global Results "CHANGE_PATH_HERE"

sysdir set PLUS "CHANGE_PATH_HERE"

*** External packages
ssc install estout, replace
ssc install binscatter, replace
ssc install unique


*** Power Calculations, Randomization, Balance

*Baseline data for Power and Randomization
do "..\Code\1_data_baseline.do"

*Randomization
do "..\Code\1_assignment.do"

*Prepare working database
do "..\Code\1_prepare_db.do"

*Balance checks of T and C
do "..\Code\1_balance_checks.do"

*Distribution of cluster sizes in six partial population experiments
*Figure 1
do "..\Code\1_Figure_1.do"

*Table A6 (run in R):
*--> run in R the following script: "..\Code\1_Table_A6.R"

*Figure 2 (run in R): Power functions - numerical illustration
*run in R the following script: "..\Code\1_Figure_2.R"

*Table 1 (run in R): Constrained and optimal cluster assignment probabilities and MDEs
*--> run in R the following script: "..\Code\1_Table_1.R"

*** Empirical Analysis of the RCT
*Tables/Figures with main effects and heterogeneity below and above median compliance in 2019
do "..\Code\2_analysis_cuota10_rawgraphs.do"
do "..\Code\2_analysis_cuota10.do"

*Analysis September 2020 bill (pre-intervention)
do "..\Code\2_analysis_cuota9.do"

*Analysis subscription to electronic bill 
do "..\Code\3_analysis_paperless.do"

*Analysis Backward and Forward Payments
do "..\Code\3_analysis_bills.do"

*Buffer analysis: to test if pure control blocks are affected
do "..\Code\4_analysis_cuota10_buffer.do"

