********************************************************************************
** Figure 1: Distribution of cluster sizes in six partial population experiments
********************************************************************************

********************************************************************************
** Cruces, Tortarolo, Vazquez-Bare
********************************************************************************

use "data_baseline.dta", clear

drop if g==""

sum gsize if tag
ret list

hist gsize if tag, disc freq graphregion(color(white)) color(gs10) xtitle("Cluster size")
graph export "$Results\cruces_etal.pdf", replace

********************************************************************************
** Gine and Mansuri
********************************************************************************

use "Data_other/Gine & Mansuri (2017)/Data/Female_Voting_Lasso.dta", clear

global g "neighborhood_code"

drop if $g==.

capture drop gsize
bysort $g: gen gsize = _N
egen tag = tag($g) 

sum gsize if tag
ret list

hist gsize if tag, disc freq graphregion(color(white)) color(gs10) xtitle("Cluster size")
graph export "$Results\gine_mansuri.pdf", replace

********************************************************************************
** Haushofer and Shapiro
********************************************************************************

use "Data_other/Haushofer and Shapiro (2016)/Data/UCT_FINAL_CLEAN.dta", clear

global g "village"

drop if $g==.

capture drop gsize
bysort $g: gen gsize = _N
egen tag = tag($g) 

sum gsize if tag
ret list

hist gsize if tag, disc freq graphregion(color(white)) color(gs10) xtitle("Cluster size")
graph export "$Results\haushofer_shapiro.pdf", replace

********************************************************************************
** Ichino and Schundeln
********************************************************************************

use "Data_other/Ichino & Schundeln (2012)/IchinoSchuendeln_spilloversJOP.dta", clear

global g "constituency"

drop if $g==""

capture drop gsize
bysort $g: gen gsize = _N
egen tag = tag($g) 

sum gsize if tag
ret list

hist gsize if tag, disc freq graphregion(color(white)) color(gs10) xtitle("Cluster size")
graph export "$Results\ichino_schundeln.pdf", replace

********************************************************************************
** Imai et al 
********************************************************************************

import delimited "Data_other/Imai et al (2020)/dataverse_files\india.csv", clear

global g "village_id"

drop if $g==.

capture drop gsize
bysort $g: gen gsize = _N
egen tag = tag($g) 

sum gsize if tag
ret list

hist gsize if tag, freq graphregion(color(white)) color(gs10) xtitle("Cluster size")
graph export "$Results\imai_etal.pdf", replace

********************************************************************************
** Crepon et al (2013)
********************************************************************************

use "Data_other/Crepon et al (2013)\Displacement_RCT_Replication_package\lil-1596\Stata\jd_publicdata.dta", clear

global g "anonale"

drop if $g==.

drop if session == 12

capture drop gsize
bysort $g: gen gsize = _N
egen tag = tag($g) 

sum gsize if tag
ret list

hist gsize if tag, freq graphregion(color(white)) color(gs10) xtitle("Cluster size")
graph export "$Results\crepon_etal.pdf", replace
