/*******************************************************************************
				Select 10 tables from Appendix at random		
				
*** PURPOSE: 			

This code is to select 10 exhbits from appendix at random when there are more
than 10 tables in appendix 
				
*** INSTRUCTIONS:		

1. Go to https://www.random.org

2. In the True Random Number Generator:
	- Set Min as 100000
	- Set Max as 999999
	
3. Copy the generated seed on line 37 as well as the GH issue (VERY IMPORTANT) 
for the package so the code can be reprodced.

4. Set the Stata version on line 34

5. Set number of exhibits in appendix in line 40

6. Line 53 will give a list of tables that need to be verified

***NOTE: 	

Change the seed each time a new package is received, or this code will 
select the same tables if n_exhibit remains the same.
*******************************************************************************/

// Clear environment
clear
version 18

// Set seed for randomization 
set seed 539174

// Set number of exhibits and observations
local n_exhibit 23
set obs `n_exhibit'

// Generate table number and random rank
gen n_table = _n
gen random = runiform()
sort random

// Select exactly 10 tables for verification
gen verify = _n <= 10

// Output which tables will be checked
sort n_table
list n_table if verify


